NTRUSigningKeyPairGenerator (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.pqc.crypto.ntru

## Class NTRUSigningKeyPairGenerator

- java.lang.Object
- - org.bouncycastle.pqc.crypto.ntru.NTRUSigningKeyPairGenerator

- All Implemented Interfaces:
    AsymmetricCipherKeyPairGenerator

      public class NTRUSigningKeyPairGenerator
      extends java.lang.Object
      implements AsymmetricCipherKeyPairGenerator

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `NTRUSigningKeyPairGenerator.FGBasis` A subclass of Basis that additionally contains the polynomials `F` and `G`.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NTRUSigningKeyPairGenerator()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `NTRUSigningPrivateKeyParameters.Basis` | `generateBoundedBasis()` Creates a basis such that `|F| < keyNormBound` and `|G| < keyNormBound`
    `AsymmetricCipherKeyPair` | `generateKeyPair()` Generates a new signature key pair.
    `AsymmetricCipherKeyPair` | `generateKeyPairSingleThread()` Generates a new signature key pair.
    `void` | `init(KeyGenerationParameters param)` intialise the key pair generator.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NTRUSigningKeyPairGenerator

          public NTRUSigningKeyPairGenerator()

  - ### Method Detail

    - #### init

          public void init(KeyGenerationParameters param)

      Description copied from interface: `AsymmetricCipherKeyPairGenerator`
      intialise the key pair generator.
      Specified by:
        `init` in interface `AsymmetricCipherKeyPairGenerator`
      Parameters:
        `param` - the parameters the key pair is to be initialised with.

    - #### generateKeyPair

          public AsymmetricCipherKeyPair generateKeyPair()

      Generates a new signature key pair. Starts `B+1` threads.
      Specified by:
        `generateKeyPair` in interface `AsymmetricCipherKeyPairGenerator`
      Returns:
        a key pair

    - #### generateKeyPairSingleThread

          public AsymmetricCipherKeyPair generateKeyPairSingleThread()

      Generates a new signature key pair. Runs in a single thread.
      Returns:
        a key pair

    - #### generateBoundedBasis

          public NTRUSigningPrivateKeyParameters.Basis generateBoundedBasis()

      Creates a basis such that `|F| < keyNormBound` and `|G| < keyNormBound`
      Returns:
        a NTRUSigner basis